src/br/com/alura/forum/model/Categoria.java
package br.com.alura.forum.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

@Entity
public class Categoria {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	private String nome;

	@ManyToOne
	private Categoria pai;

	@OneToMany(mappedBy = "pai")
	private List<Categoria> subcategorias = new ArrayList<>();

	/**
	 * @deprecated
	 */
	public Categoria() {
	}

	public Categoria(String nome) {
		this.nome = nome;
	}

	public Categoria(String nome, Categoria pai) {
		this(nome);
		this.pai = pai;
	}

	public Long getId() {
		return id;
	}

	public String getNome() {
		return nome;
	}

	public Optional<Categoria> getPai() {
		return Optional.ofNullable(this.pai);
	}

	public List<String> getNomesDasSubcategorias() {
		return this.subcategorias.stream().map(Categoria::getNome).collect(Collectors.toList());
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((nome == null) ? 0 : nome.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Categoria other = (Categoria) obj;
		if (nome == null) {
			if (other.nome != null)
				return false;
		} else if (!nome.equals(other.nome))
			return false;
		return true;
	}

}

src/br/com/alura/forum/model/Curso.java
package br.com.alura.forum.model;

import java.util.Optional;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

@Entity
public class Curso {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	private String nome;

	@ManyToOne
	private Categoria subcategoria;

	/**
	 * @deprecated
	 */
	public Curso() {
	}

	public Curso(String nome, Categoria subcategoria) {
		this.nome = nome;
		this.subcategoria = subcategoria;
	}

	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	
	public String getNome() {
		return nome;
	}

	public Categoria getSubcategoria() {
		return subcategoria;
	}

	public String getNomeSubcategoria() {
		return subcategoria.getNome();
	}

	public String getNomeCategoria() {
		Optional<Categoria> categoria = this.subcategoria.getPai();

		return categoria.orElseThrow(() -> new IllegalStateException("Esta já é uma categoria pai")).getNome();
	}

}

src/br/com/alura/forum/model/Perfil.java
package br.com.alura.forum.model;

import javax.persistence.Entity;
import javax.persistence.Id;

import org.springframework.security.core.GrantedAuthority;

@Entity
public class Perfil implements GrantedAuthority {
	
	private static final long serialVersionUID = 1L;
	
	@Id
	private String nome;
	
	/**
	 * @deprecated
	 */
	public Perfil() {
	}
	
	public Perfil(String nome) {
		this.nome = nome;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((nome == null) ? 0 : nome.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Perfil other = (Perfil) obj;
		if (nome == null) {
			if (other.nome != null)
				return false;
		} else if (!nome.equals(other.nome))
			return false;
		return true;
	}

	public String getNome() {
		return nome;
	}
	
	public void setNome(String nome) {
		this.nome = nome;
	}
	
	@Override
	public String getAuthority() {
		return nome;
	}
	
}

src/br/com/alura/forum/model/Topico.java
package br.com.alura.forum.model;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.springframework.util.Assert;

@Entity
public class Topico {

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private Long id;
	
	private String titulo;
	
	@Lob
	private String descricao;
	
	private LocalDateTime dataCriacao = LocalDateTime.now();
	private LocalDateTime dataUltimaAtualizacao = LocalDateTime.now();
	
	@Enumerated(EnumType.STRING)
	private StatusTopico status = StatusTopico.NAO_RESPONDIDO;

	@ManyToOne
	private Usuario autor;
	
	@ManyToOne
	private Curso curso;
	
	@OneToMany(mappedBy = "topico")
	private List<Resposta> respostas = new ArrayList<>();
	
	/**
	 * @deprecated
	 */
	protected Topico() {}
	
	public Topico(String titulo, String descricao, Usuario autor, Curso curso) {
		this.titulo = titulo;
		this.descricao = descricao;
		this.autor = autor;
		this.curso = curso;
	}
	
	public void addResposta(Resposta nova) {
		this.respostas.add(nova);
		atualizarDataDeUltimaAtualizacao();
	}

	public void registrarNovaResposta(Resposta nova) {
		Assert.notNull(nova, "Nova resposta não pode ser nula");

		this.status.registrarNovaResposta(this, nova);
	}
	
	public void marcarComoSolucionado() {
		this.status = StatusTopico.SOLUCIONADO;
		atualizarDataDeUltimaAtualizacao();
	}

	public void fechar() {
		this.status = StatusTopico.FECHADO;
		atualizarDataDeUltimaAtualizacao();
	}

	public boolean isSolucionado() {
		return StatusTopico.SOLUCIONADO == this.status;
	}

	public boolean isFechado() {
		return StatusTopico.FECHADO == this.status;
	}
	
	private void atualizarDataDeUltimaAtualizacao() {
		this.dataUltimaAtualizacao = LocalDateTime.now();
	}

	public Long getId() {
		return id;
	}

	public String getTitulo() {
		return titulo;
	}
	
	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}
	
	public String getDescricao() {
		return descricao;
	}
	
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	
	public LocalDateTime getDataCriacao() {
		return dataCriacao;
	}

	public LocalDateTime getDataUltimaAtualizacao() {
		return dataUltimaAtualizacao;
	}

	public Usuario getAutor() {
		return autor;
	}
	
	public void setAutor(Usuario autor) {
		this.autor = autor;
	}

	public String getNomeAutor() {
		return autor.getNome();
	}

	public Curso getCurso() {
		return curso;
	}
	
	public void setCurso(Curso curso) {
		this.curso = curso;
	}

	public String getEmailAutor() {
		return autor.getEmail();
	}

	public Integer getNumeroDeRespostas() {
		return this.respostas.size();
	}

	public StatusTopico getStatus() {
		return status;
	}

	public void setStatus(StatusTopico status) {
		this.status = status;
	}

	public List<Resposta> getRespostas() {
		return Collections.unmodifiableList(this.respostas);
	}

}

src/br/com/alura/forum/model/Usuario.java
package br.com.alura.forum.model;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Objects;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;

import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

@Entity
public class Usuario implements UserDetails {

	private static final long serialVersionUID = 1L;

	private static final Perfil PERFIL_MODERADOR = new Perfil("ROLE_MODERADOR");

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	private String nome;

	private String senha;

	@Column(nullable = false, unique = true)
	private String email;

	@ManyToMany(fetch = FetchType.EAGER, cascade = {CascadeType.PERSIST, CascadeType.MERGE})
	private List<Perfil> perfis = new ArrayList<>();

	/**
	 * @deprecated
	 */
	public Usuario() {
	}

	public Usuario(String nome, String email, String senha) {
		this.nome = nome;
		this.email = email;
		this.senha = senha;
	}
	
	public boolean isModerador() {
		return perfis.contains(PERFIL_MODERADOR);
	}
	
	public void addPerfil(Perfil perfil) {
		this.perfis.add(perfil);
	}
	
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || getClass() != o.getClass())
			return false;
		Usuario user = (Usuario) o;
		return Objects.equals(email, user.email);
	}

	@Override
	public int hashCode() {
		return Objects.hash(email);
	}

	public Long getId() {
		return this.id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}

	public String getNome() {
		return nome;
	}
	
	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getSenha() {
		return this.senha;
	}
	
	public void setSenha(String senha) {
		this.senha = senha;
	}

	public String getEmail() {
		return this.email;
	}
	
	public void setEmail(String email) {
		this.email = email;
	}
	
	public List<Perfil> getPerfis() {
		return perfis;
	}
	
	public void setPerfis(List<Perfil> perfis) {
		this.perfis = perfis;
	}
	
	@Override
	public Collection<? extends GrantedAuthority> getAuthorities() {
		return perfis;
	}

	@Override
	public String getUsername() {
		return email;
	}
	
	@Override
	public String getPassword() {
		return senha;
	}

	@Override
	public boolean isAccountNonExpired() {
		return true;
	}

	@Override
	public boolean isAccountNonLocked() {
		return true;
	}

	@Override
	public boolean isCredentialsNonExpired() {
		return true;
	}

	@Override
	public boolean isEnabled() {
		return true;
	}

}

WebContent/WEB-INF/views/dashboard.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>

<c:url var="images" value="/static/images" />

<main class="dashboard">
	<div class="container">
		<ul class="dashboard-categoryList">
			<c:forEach items="${dashboardVo.itensDashboard}" var="item">
				<c:choose>
					<c:when test="${item.categoriaMobile}">
						<c:set var="cor" value="#fdc14a"/>
						<c:set var="categoria" value="mobile"/>
					</c:when>
					
					<c:when test="${item.categoriaProgramacao}">
						<c:set var="cor" value="#00c86f"/>
						<c:set var="categoria" value="programacao"/>
					</c:when>
					
					<c:when test="${item.categoriaFrontend}">
						<c:set var="cor" value="#009bdd"/>
						<c:set var="categoria" value="front-end"/>
					</c:when>
					
					<c:when test="${item.categoriaInfra}">
						<c:set var="cor" value="#f1634b"/>
						<c:set var="categoria" value="infraestrutura"/>
					</c:when>
					
					<c:when test="${item.categoriaDesign}">
						<c:set var="cor" value="#9d60b8"/>
						<c:set var="categoria" value="design-ux"/>
					</c:when>
					
					<c:when test="${item.categoriaBusiness}">
						<c:set var="cor" value="#0079ac"/>
						<c:set var="categoria" value="business"/>
					</c:when>
					
					<c:when test="${item.categoriaOfftopic}">
						<c:set var="cor" value="#9eb3c1"/>
						<c:set var="categoria" value="offtopic"/>
					</c:when>
					
					<c:otherwise>
						<c:set var="cor" value="#697074"/>
					</c:otherwise>
				</c:choose>
				
				
				<li class="dashboard-categoryList-category" style="border-left-color: ${cor}">
					<img class="dashboard-categoryList-category-icon" src="${images}/${categoria}.svg" alt="Categoria ${item.nomeCategoria}" aria-hidden="true">
	
					<div class="dashboard-categoryList-category-name">
						<a class="dashboard-category-name-text" style="color: ${cor}" href="#">
							${item.nomeCategoria}
						</a>
					</div>
	
					<ul class="dashboard-categoryList-category-stats">
						<li class="categoryList-category-stats-item dashboard-category-stats-topics">
							<span class="category-stats-item-number dashboard-stats-topics-number">${item.qtdTopicos}</span>
							<a class="category-stats-item-text dashboard-stats-topics-text" href="#">tópicos</a>
						</li>
						<li class="categoryList-category-stats-item dashboard-category-stats-lastWeek">
							<span class="category-stats-item-number dashboard-stats-lastWeek-number">${item.qtdTopicosDaUltimaSemana}</span>
							<span class="category-stats-item-text dashboard-stats-lastWeek-text">na última semana</span>
						</li>
						<li class="categoryList-category-stats-item dashboard-category-stats-noReply">
							<span class="category-stats-item-number dashboard-stats-noReply-number">${item.qtdTopicosNaoRespondidos}</span>
							<a class="category-stats-item-text dashboard-stats-noReply-text" href="#">sem resposta</a>
						</li>
					</ul>
	
					<div class="dashboard-categoryList-category-subcategories">
						<ul class="dashboard-category-subcategories-list">
							<c:forEach items="${item.nomesDasSubcategorias}" var="subcategoria">
								<li class="dashboard-subcategories-list-subcategory">
									<a class="dashboard-list-subcategory-link" href="#">
										${subcategoria}
									</a>
								</li>
							</c:forEach>
						</ul>
	
						<button tabindex="0" class="dashboard-category-subcategories-dropdownButton">
							<span class="dashboard-subcategories-dropdownButton-text">ver subcategorias</span>
						</button>
					</div>
				</li>
			</c:forEach>
		</ul>
	</div>
</main>

WebContent/WEB-INF/views/detalhes-topico.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib prefix="sec" uri="http://www.springframework.org/security/tags"%>
<%@ taglib prefix="custom" tagdir="/WEB-INF/tags/template"%>

<c:url var="images" value="/static/images" />

<sec:authorize access="isAuthenticated()">
	<sec:authentication property="principal" var="usuario" />
	
	<c:if test="${usuario.moderador}">
		<c:set var="moderador" value="true"/>
	</c:if>
</sec:authorize>

<custom:template>
	<jsp:body>
		<div class="topic">
			<section class="banner">
				<div class="container">
					<h1 class="banner-title">
						<a href="#" class="banner-title-link">Fórum </a>
					</h1>
				</div>
			</section>

			<div class="topic-body">
				<c:if test="${topico.solucionado}">
					<div class="topic-solved">
						<div class="container">
							<p class="topic-solved-text">Solucionado</p>
						</div>
					</div>
				</c:if>
				
				<div class="container"></div>
				
				<header class="topic-header">
					<div class="topic-header-container">
						<div class="topic-header-container-info">
							<h1 class="topic-header-container-title"><c:out value="${topico.titulo}"/></h1>
							
							<c:choose>
								<c:when test="${topico.categoriaMobile}">
									<c:set var="cor" value="#fdc14a"/>		
								</c:when>
								
								<c:when test="${topico.categoriaProgramacao}">
									<c:set var="cor" value="#00c86f"/>		
								</c:when>
								
								<c:when test="${topico.categoriaFrontend}">
									<c:set var="cor" value="#009bdd"/>		
								</c:when>
								
								<c:when test="${topico.categoriaInfra}">
									<c:set var="cor" value="#f1634b"/>		
								</c:when>
								
								<c:when test="${topico.categoriaDesign}">
									<c:set var="cor" value="#9d60b8"/>		
								</c:when>
								
								<c:when test="${topico.categoriaBusiness}">
									<c:set var="cor" value="#0079ac"/>		
								</c:when>
								
								<c:when test="${topico.categoriaOfftopic}">
									<c:set var="cor" value="#9eb3c1"/>		
								</c:when>
								
								<c:otherwise>
									<c:set var="cor" value="#697074"/>
								</c:otherwise>
							</c:choose>
							
							<style>
								@media ( min-width : 720px) {
									#topic-breadCrumb-item-category-${topico.id} {
										background: ${cor};
									}
									#topic-breadCrumb-item-subcategory-${topico.id} {
										background: ${cor};
										opacity: .8;
									}
									#topic-breadCrumb-item-course-${topico.id} {
										background: ${cor};
										opacity: .6;
									}
								}
								
								@media not all and (min-width: 720px) {
									#topic-breadCrumb-item-category-${topico.id} {
										color: ${cor};
									}
									#topic-breadCrumb-item-subcategory-${topico.id} {
										color: ${cor};
										opacity: .8;
									}
									#topic-breadCrumb-item-course-${topico.id} {
										color: ${cor};
										opacity: .6;
									}
								}
							</style>

							<nav class="topic-breadCrumb">
								<ol class="topic-breadCrumb-list">
									<li class="topic-breadCrumb-item">
										<a id="topic-breadCrumb-item-category-${topico.id}" href="#" class="topic-breadCrumb-item-link">${topico.nomeCategoria}</a>
									</li>
		
									<li class="topic-breadCrumb-item">
										<a id="topic-breadCrumb-item-subcategory-${topico.id}" href="#" class="topic-breadCrumb-item-link">${topico.nomeSubcategoria}</a>
									</li>
		
									<li class="topic-breadCrumb-item">
										<a id="topic-breadCrumb-item-course-${topico.id}" href="#" class="topic-breadCrumb-item-link">${topico.nomeCurso}</a>
									</li>
								</ol>
							</nav>
							
							<sec:authorize access="isAuthenticated()">
								<c:if test="${not topico.fechado and (usuario.id eq topico.idAutor or moderador)}">
									<div class="topic-container-details-moderator">
										<a id="close-link" href="#">Fechar tópico </a>
										
										<form id="form-close" style="display:none;" method="POST" action="<c:url value="/topicos/${topico.id}/fechar"/>">
											<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}">
										</form>
									</div>
								</c:if>
							</sec:authorize>
						</div>
				
						<div class="topic-header-container-details">
							<div class="topic-header-container-details-date">
								<time datetime="${topico.dataCriacao}">${topico.dataCriacaoPretty}</time>
							</div>
						</div>
					</div>
				</header>

				<section class="topic-post">
					<div class="container">		
						<section class="topic-post-header">
							<section class="topic-post-author">
								<a href="#" class="topic-post-author-photo">
									<img src="${images}/avatar.png" alt="Foto do <c:out value="${topico.nomeAutor}"/>" class="topic-post-author-photo-img">
								</a>

								<div class="topic-post-author-details">
									<a href="#" class="topic-post-author-name"><c:out value="${topico.nomeAutor}"/></a>
									<span class="topic-post-author-desc"></span>
								</div>
							</section>
						</section>

						<section class="topic-post-content" data-external-links="">
							<c:out value="${topico.descricao}"/>
						</section>
				
						<div class="topic-post-actions"></div>
					</div>
				</section>

				<section class="topic-answers">
					<div class="topic-answers-banner">
						<div class="container">
							${topico.quantidadeRespostas} <span>respostas</span>
						</div>
					</div>
					
					<c:forEach items="${topico.respostas}" var="resposta">
						<section class="topic-post">
							<div class="container">	
								<c:if test="${resposta.solucao}">
									<div class="topic-post-solved">
										<span class="topic-post-solved-text">solução</span>
									</div>	
								</c:if>
									
								<section class="topic-post-header">
									<section class="topic-post-author">
										<a href="#" class="topic-post-author-photo">
											<img src="${images}/avatar.png" alt="Foto do <c:out value="${resposta.nomeAutor}"/>" class="topic-post-author-photo-img">
										</a>
									
										<div class="topic-post-author-details">
											<a href="#" class="topic-post-author-name"><c:out value="${resposta.nomeAutor}"/></a>
											
											<c:if test="${resposta.moderador}">
												<span class="topic-post-author-moderator">Moderador</span>
											</c:if>
										</div>
									</section>
			
									<time datetime="${resposta.dataCriacao}">
										<span class="topic-post-date">${resposta.dataCriacaoPretty}</span>
									</time>
								</section>

								<section class="topic-post-content" data-external-links="">
									<c:out value="${resposta.descricao}"/>
								</section>

								<div class="topic-post-actions">
									<sec:authorize access="isAuthenticated()">
										<c:if test="${not topico.solucionado and not topico.fechado and (usuario.id eq topico.idAutor or moderador)}">
											<form class="topic-post-solveForm" action="<c:url value="/topicos/${topico.id}/solucionar" />" method="POST">
												<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}">
												<input type="hidden" value="${resposta.id}" name="idResposta">
												
												<button type="submit" class="topic-button topic-post-solveButton">
													<span class="topic-post-solveButton-hideMobile">Marcar como</span> solução
												</button>
						                    </form>
										</c:if>
									</sec:authorize>
								</div>
							</div>
						</section>
					</c:forEach>
				</section>
				
				<c:if test="${topico.solucionado}">
					<div class="container">
						<div class="alert" data-category="alert" role="alert">
							<img alt="alerta" class="alert-icon" src="${images}/alert.svg">
							<p class="alert-message">Esta dúvida já foi marcada como solucionada, se a dúvida ainda persiste, por favor abra outra discussão.</p>
						</div>
					</div>
				</c:if>
				
				<c:if test="${topico.fechado}">
					<div class="container">
						<div class="alert" data-category="alert" role="alert">
							<img alt="alerta" class="alert-icon" src="${images}/alert.svg">
							<p class="alert-message">Esta dúvida está fechada, se a dúvida ainda persiste, por favor abra outra discussão.</p>
						</div>
					</div>
				</c:if>
				
				<c:if test="${usuario ne null and not topico.fechado}">
					<section class="topic-reply">
						<div class="container">
							<h2 class="topic-reply-title">O que você acha disso?</h2>
							<form action="<c:url value="/topicos/${topico.id}/responder" />" method="post" class="topic-reply-form">
								<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}">
								<input type="hidden" name="idTopico" value="${topico.id}">
	
								<div class="markdownEditor isToggled" id="markdownEditor-">
									<div class="markdownEditor-buttons">
										<button class="markdownEditor-button markdownEditor-button-code " data-insert-code="insira seu código aqui" type="button">Inserir código</button>
										
										<div class="markdownEditor-buttons-options">
											<button class="markdownEditor-button markdownEditor-button-preview isToggled" type="button" data-js-toggle="#markdownEditor-">Expandir</button>
											<button aria-controls="markdownEditor-help" aria-expanded="false" class="markdownEditor-button markdownEditor-button-format" type="button" data-js-toggle="#markdownEditor- .markdownEditor-help" aria-label="Abrir instruções de formatação do texto">Formatação</button>
										</div>
									</div>
	
									<div class="markdownEditor-area">
										<aside class="markdownEditor-help formattedText" aria-hidden="true" id="markdownEditor-help" tabindex="0">
											<h2>How to format code</h2>
											<ul>
												<li>É possível criar blocos de código adicionando três backticks (```) antes e depois do código</li>
												<li>Para escapar a formatação, utilize crases `dessa _forma_`</li>
												<li>Serão exibidas apenas tags HTML e XML que estiverem entre `<crases>`</crases></li>
											</ul>
	
											<h2>Formatação básica</h2>
											<ul>
												<li>**<strong>negrito</strong>**</li>
												<li>*<em>itálico</em>*</li>
												<li>~~<del>riscado (Strikethrough)</del>~~ </li>
											</ul>
	
											<h2>Como formatar links</h2>
											<ul>
												<li>&lt;http://google.com&gt;</li>
												<li>[Google](http://google.com)</li>
											</ul>
										</aside>
	
										<textarea aria-live="polite" aria-atomic="true" class="markdownEditor-source markdownEditor-textArea " name="descricao" maxlength="5000" id="markdownEditor--ta"></textarea>
										<output class="markdownEditor-preview formattedText markdownEditor-textArea " for="markdownEditor--ta"></output>
									</div>
								</div>
								
								<input class="topic-reply-form-submit" type="submit" value="Responder">
							</form>
						</div>
					</section>
				</c:if>
			</div>
		</div>
	</jsp:body>
</custom:template>

WebContent/WEB-INF/views/form-cadastro.jsp
<%@ page language="java" contentType="text/html; charset=UTF-8"	pageEncoding="UTF-8"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib prefix="custom" tagdir="/WEB-INF/tags/template"%>

<c:url var="images" value="/static/images" />

<custom:template>
	<jsp:body>
		<div class="container">
			<section class="sign">
				<section class="signin">
					<h2 class="title">Quer participar do fórum?</h2>
					<p class="subtitle">Cadastre-se gratuitamente!</p>
					
					
					<c:if test="${not empty mensagemErro}">
						<div class="alert" data-category="error" role="alert">
							<img alt="" class="alert-icon" src="${images}/error.svg">
							<p class="alert-message">${mensagemErro}</p>
						</div>
					</c:if>
					
					<form class="signin-form" action="<c:url value="/usuarios/cadastro" />" method="post">
						<input type="hidden" name="${_csrf.parameterName}" value="${_csrf.token}">
						
						<label for="cadastro-nome">Nome</label>
						<input required="required" name="nome" id="cadastro-nome" autofocus="autofocus" value="${usuario.nome}">
						
						<label for="cadastro-email">E-mail</label>
						<input type="email" required="required" name="email" id="cadastro-email" value="${usuario.email}">
		
						<label for="cadastro-senha">Senha</label>
						<input type="password" required="required" name="senha" id="cadastro-senha">
						
						<label for="cadastro-confirmacaoSenha">Confirmação Senha</label>
						<input type="password" required="required" name="confirmacaoSenha" id="cadastro-confirmacaoSenha">
						
						<button class="btn-login" type="submit">Cadastrar</button>
					</form>
				</section>
			</section>
		</div>
	</jsp:body>
</custom:template>